// Copyright (C) 2010 - DIGITEO - Michael Baudin
// Copyright (C) 2009 - Pascal Getreuer
//
// <-- JVM NOT MANDATORY -->
// <-- ENGLISH IMPOSED -->

//
// assert_close --
//   Returns 1 if the two real matrices computed and expected are close,
//   i.e. if the relative distance between computed and expected is lesser than epsilon.
// Arguments
//   computed, expected : the two matrices to compare
//   epsilon : a small number
//
function flag = assert_close ( computed, expected, epsilon )
  if expected==0.0 then
    shift = norm(computed-expected);
  else
    shift = norm(computed-expected)/norm(expected);
  end
  if shift < epsilon then
    flag = 1;
  else
    flag = 0;
  end
  if flag <> 1 then pause,end
endfunction
//
// assert_equal --
//   Returns 1 if the two real matrices computed and expected are equal.
// Arguments
//   computed, expected : the two matrices to compare
//
function flag = assert_equal ( computed , expected )
  if ( and ( computed==expected ) ) then
    flag = 1;
  else
    flag = 0;
  end
  if flag <> 1 then pause,end
endfunction

//
// assert_true --
//   Returns 1 if the condition is true
// Arguments
//   computed : the matrix of booleans
//
function flag = assert_true ( computed )
  if ( and ( computed ) ) then
    flag = 1;
  else
    flag = 0;
  end
  if flag <> 1 then pause,end
endfunction
assert_equal ( specfun_nchoosek ( 4 , 1 ) , 4 );
assert_equal ( specfun_nchoosek ( 5 , 0 ) , 1 );
assert_equal ( specfun_nchoosek ( 5 , 1 ) , 5 );
assert_equal ( specfun_nchoosek ( 5 , 2 ) , 10 );
assert_equal ( specfun_nchoosek ( 5 , 3 ) , 10 );
assert_equal ( specfun_nchoosek ( 5 , 4 ) , 5 );
assert_equal ( specfun_nchoosek ( 5 , 5 ) , 1 );
assert_close ( specfun_nchoosek ( 10000 , 134 ) , 2.050083865033972676e307 , 1.e-10 );
assert_equal ( specfun_nchoosek (10,0:10) , [1,10,45,120,210,252,210,120,45,10,1] );


