// Copyright (C) 2010 - DIGITEO - Michael Baudin
// Copyright (C) 2009 - Pascal Getreuer
//
// <-- JVM NOT MANDATORY -->
// <-- ENGLISH IMPOSED -->

//
// assert_close --
//   Returns 1 if the two real matrices computed and expected are close,
//   i.e. if the relative distance between computed and expected is lesser than epsilon.
// Arguments
//   computed, expected : the two matrices to compare
//   epsilon : a small number
//
function flag = assert_close ( computed, expected, epsilon )
  if expected==0.0 then
    shift = norm(computed-expected);
  else
    shift = norm(computed-expected)/norm(expected);
  end
  if shift < epsilon then
    flag = 1;
  else
    flag = 0;
  end
  if flag <> 1 then pause,end
endfunction
//
// assert_equal --
//   Returns 1 if the two real matrices computed and expected are equal.
// Arguments
//   computed, expected : the two matrices to compare
//
function flag = assert_equal ( computed , expected )
  if ( and ( computed==expected ) ) then
    flag = 1;
  else
    flag = 0;
  end
  if flag <> 1 then pause,end
endfunction

//
// assert_true --
//   Returns 1 if the condition is true
// Arguments
//   computed : the matrix of booleans
//
function flag = assert_true ( computed )
  if ( and ( computed ) ) then
    flag = 1;
  else
    flag = 0;
  end
  if flag <> 1 then pause,end
endfunction

n=5;
U = [
    1.    1.    1.    1.    1.  
    0.    1.    2.    3.    4.  
    0.    0.    1.    3.    6.  
    0.    0.    0.    1.    4.  
    0.    0.    0.    0.    1.  
];
S = [
    1.    1.    1.     1.     1.   
    1.    2.    3.     4.     5.   
    1.    3.    6.     10.    15.  
    1.    4.    10.    20.    35.  
    1.    5.    15.    35.    70.  
];
//
computed = specfun_pascal ( n );
assert_equal ( computed , S );
//
computed = specfun_pascal ( n , 0 );
assert_equal ( computed , S );
//
computed = specfun_pascal ( n , 1 );
assert_equal ( computed , U' );
//
computed = specfun_pascal ( n , -1 );
assert_equal ( computed , U );
//
computed = specfun_pascal ( 0 , -1 );
assert_equal ( computed , [] );
//
computed = specfun_pascal ( 0 , 0 );
assert_equal ( computed , [] );
//
computed = specfun_pascal ( 0 , 1 );
assert_equal ( computed , [] );
//
computed = specfun_pascal ( 1 , -1 );
assert_equal ( computed , 1 );
//
computed = specfun_pascal ( 1 , 0 );
assert_equal ( computed , 1 );
//
computed = specfun_pascal ( 1 , 1 );
assert_equal ( computed , 1 );
//





